%     AERO LOAD - программа для нагружения агрегатов самолета распределенной нагрузкой
%     Copyright (C) 2018-2024  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function Force = Get_Element_Force(Load, Index)

global ErrCode;

global DB_ELEMENTS;
global AT_NODES;
global PROJECTED_NODES;

switch DB_ELEMENTS{Index}.N_nodes
    
    case 3
        
        Point_1 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(1)),:)';
        Point_2 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(2)),:)';
        Point_3 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(3)),:)';
        
        Force = Triangle_Force(Load, Point_1, Point_2, Point_3);
        
    case 4
        
        Point_1 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(1)),:)';
        Point_2 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(2)),:)';
        Point_3 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(3)),:)';
        Point_4 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(4)),:)';
        
        Mid_diag = (Point_1 + Point_3)/2;

        CG1 = Mid_diag*2/3 + Point_2/3;
        CG2 = Mid_diag*2/3 + Point_4/3;

        s_half_1 = Triangle_Area(Point_1, Point_2, Point_3);
        s_half_2 = Triangle_Area(Point_1, Point_3, Point_4);

        Centroid = CG1 * s_half_1/(s_half_1 + s_half_2) + CG2 * s_half_2/(s_half_1 + s_half_2);

        Force = Triangle_Force(Load, Point_1, Point_2, Centroid) + ...
                Triangle_Force(Load, Point_2, Point_3, Centroid) + ...
                Triangle_Force(Load, Point_3, Point_4, Centroid) + ...
                Triangle_Force(Load, Point_4, Point_1, Centroid);
        
    case 6
        
        Point_1 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(1)),:)';
        Point_2 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(2)),:)';
        Point_3 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(3)),:)';
        Point_4 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(4)),:)';
        Point_5 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(5)),:)';
        Point_6 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(6)),:)';
        
        Force = Triangle_Force(Load, Point_1, Point_4, Point_6) + ...
                Triangle_Force(Load, Point_4, Point_2, Point_5) + ...
                Triangle_Force(Load, Point_6, Point_5, Point_3) + ...
                Triangle_Force(Load, Point_4, Point_5, Point_6);
        
    case 8
        
        Point_1 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(1)),:)';
        Point_2 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(2)),:)';
        Point_3 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(3)),:)';
        Point_4 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(4)),:)';
        Point_5 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(5)),:)';
        Point_6 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(6)),:)';
        Point_7 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(7)),:)';
        Point_8 = PROJECTED_NODES(AT_NODES(DB_ELEMENTS{Index}.Nodes(8)),:)';
        
        Mid_diag = (Point_5 + Point_7)/2;

        CG1 = Mid_diag*2/3 + Point_6/3;
        CG2 = Mid_diag*2/3 + Point_8/3;

        s_half_1 = Triangle_Area(Point_5, Point_6, Point_7);
        s_half_2 = Triangle_Area(Point_5, Point_7, Point_8);

        Centroid = CG1 * s_half_1/(s_half_1 + s_half_2) + CG2 * s_half_2/(s_half_1 + s_half_2);

        Force = Triangle_Force(Load, Point_5, Point_6, Centroid) + ...
                Triangle_Force(Load, Point_6, Point_7, Centroid) + ...
                Triangle_Force(Load, Point_7, Point_8, Centroid) + ...
                Triangle_Force(Load, Point_8, Point_5, Centroid) + ...
                Triangle_Force(Load, Point_1, Point_5, Point_8) + ...
                Triangle_Force(Load, Point_2, Point_6, Point_5) + ...
                Triangle_Force(Load, Point_3, Point_7, Point_6) + ...
                Triangle_Force(Load, Point_4, Point_8, Point_7);
        
    otherwise
        
        Force = 0;
        
        fprintf (1, '\nОшибка функции Get_Element_Force: недопустимое число узлов элемента с номером %i !\n', DB_ELEMENTS{Index}.ID);
        ErrCode = -1;
        return;
    
end
